package com.allinpay.demo.trx.qpay;

import com.allinpay.demo.AIPGException;
import com.allinpay.demo.DemoConfig;
import com.allinpay.demo.util.HttpUtil;
import com.allinpay.demo.util.DemoUtil;
import com.allinpay.demo.xml.XmlParser;
import com.allinpay.demo.xstruct.common.AipgReq;
import com.allinpay.demo.xstruct.common.AipgRsp;
import com.allinpay.demo.xstruct.common.InfoReq;
import com.allinpay.demo.xstruct.common.InfoRsp;
import com.allinpay.demo.xstruct.quickpay.FAGRA;
import com.allinpay.demo.xstruct.quickpay.FAGRARET;

/**
 * @Description  快捷签约短信发起
 * @Author meixf@allinpay.com
 * @Date 2018年5月24日
 **/
public class Tranx310001 {

	public static void main(String args[]){
		InfoReq inforeq = DemoUtil.makeReq("310001");

		FAGRA fagra = new FAGRA();
/*		fagra.setBANK_CODE("0102");*/

		/* fagra.setBANK_CODE("0107"); */
		fagra.setACCOUNT_NO("6214850445682229");//
		fagra.setACCOUNT_PROP("0");
		fagra.setTEL("18356097916");//
		fagra.setID("341203198909011648");//
		fagra.setID_TYPE("0");
		fagra.setACCOUNT_NAME("1");	fagra.setMERCHANT_ID(DemoConfig.merchantid);
		/* fagra.setCREDIT_ACCTNO("5289311645017262"); */
		/*fagra.setCVV2("095");
		fagra.setVALIDDATE("2103");*/
		fagra.setMERREM("123");
		fagra.setREMARK("123123123");
		/* fagra.setEXPIRED("20281025"); */
		AipgReq req = new AipgReq();
		req.setINFO(inforeq);
		req.addTrx(fagra);
		try{
			//step1 对象转xml
			String xml = XmlParser.toXml(req);
			//step2 加签
			String signedXml = DemoUtil.buildSignedXml(xml.replaceAll("\\s+", ""));
			System.out.println( "*******************6666666*********");
			System.out.println(signedXml);
			//step3 发往通联
			String url = DemoConfig.url;
			System.out.println("============================请求报文============================");
			System.out.println(signedXml);
			String respText = HttpUtil.post(signedXml, url);
			System.out.println("============================响应报文============================");
			System.out.println(respText);
			//step4 验签
			if(!DemoUtil.verifyXml(respText)){
				System.out.println("====================================================>验签失败");
				return;
			}
			System.out.println("====================================================>验签成功");
			//step5 xml转对象
			AipgRsp rsp = XmlParser.parseRsp(respText);
			InfoRsp infoRsp = rsp.getINFO();
			System.out.println(infoRsp.getRET_CODE());
			System.out.println(infoRsp.getERR_MSG());
			if("0000".equals(infoRsp.getRET_CODE())){
				FAGRARET fr = (FAGRARET)rsp.trxObj();
				System.out.println(fr.getRET_CODE());
				System.out.println(fr.getERR_MSG());
			}
		}catch(AIPGException e){
			e.printStackTrace();
		}
	}
}
